/********************************************************
 * Information batch a batch.  Common to all batches	*
 ********************************************************/
#ifndef __BATCH_INFO_C_H__
#define __BATCH_INFO_C_H__

#include <string>

#include "config.h"

/********************************************************
 * Information batch a batch.  Common to all batches	*
 ********************************************************/
class batch_info_c {
    public:
	std::string type;	// Type of batch

	unsigned int batch_number;// A batch serial number
	string_set files;	// Files in this batch

	std::string name;	// Name of the backup

	std::string backup_cmd;	// Command to do backup
	std::string restore_cmd;// Command to do restore
	std::string verify_cmd; // Command to verify the I/O

	bool names_needed;	// Do we use file names?

    public:
	explicit batch_info_c(
	    const std::string i_type,
	    const unsigned int i_batch_number,	// The batch number
	    const string_set& i_files
	):  type(i_type),
	    batch_number(i_batch_number),
	    files(i_files),
	    backup_cmd(""),
	    restore_cmd(""),
	    verify_cmd("")
	{}

	batch_info_c(void): type("Unknown") {}

	virtual ~batch_info_c() {};
	// Copy constructor defaults
	// Assignment operator defaults
};

#endif /* __BATCH_INFO_C_H__ */

