/********************************************************
 * collection_batch -- Create a collection containing 	*
 * a bunch of files.					*
 ********************************************************/
#ifndef __TAR_BATCH_H__
#define __TAR_BATCH_H__

#include <sys/types.h>

#include "config.h"
#include "filer.h"
#include "batch_b.h"

/********************************************************
 * collection_batch_b -- Backup files as a set of files	*
 ********************************************************/
class collection_batch_b: public batch_b {
    private:
	size_t batch_limit;		// How must data for the batch
	size_t file_limit;		// Biggest file allowed
	size_t current_size;		// Size of the stuff done so far
	string_set current_files;	// Files we are batching

    public:
	collection_batch_b(const std::string& name,
		const config& config);
	~collection_batch_b() {};

    private:
	collection_batch_b(const collection_batch_b&); // No copy constructor

	// No assignment operator
	collection_batch_b& operator = (const collection_batch_b&);	
    public:
	status add_files(filer &the_filer);
	batch_info_b* create_batch(void);
};

#endif /* __TAR_BATCH_H__ */


