/********************************************************
 * collection_batch - Handle restore of collections.	*
 ********************************************************/
#ifndef __TAR_BATCH_R_H__
#define __TAR_BATCH_R_H__

#include <sys/types.h>

#include "config.h"
#include "filer.h"
#include "batch_r.h"

/********************************************************
 * collection_batch_info_r -- Information on a 		*
 * collection batch and the functions to restore it.	*
 ********************************************************/
class collection_batch_info_r: public batch_info_r {
    public:
	collection_batch_info_r(
	    const batch_info_r& info,
	    std::istream& in_file
	);
	~collection_batch_info_r() {};

    private:
	// No copy constructor
	collection_batch_info_r(const collection_batch_info_r&); 

	// No assignment operator
	collection_batch_info_r& operator = (const collection_batch_info_r&);	

	friend class collection_batch_r;
};
/********************************************************
 * collection_batch_r -- Handle the batching for a 	*
 * collection restore.					*
 ********************************************************/
class collection_batch_r: public batch_r {
    public:
	// Constructor defaults
	// Destructor defaults
	// Copy Constructor defaults
	// Assignment operator defaults
    public:
	// Verify a batch
	void verify(
	    const meta_r::info_set& info,
	    io_r* const io 
	);
	// Restore a batch
	void restore(
	     const meta_r::info_set& set,
	     io_r* const io,
	     const string_set& files
	);
};
#endif /* __TAR_BATCH_R_H__ */
