/********************************************************
 * slice_batch_b -- Backup files by creating a tar	*
 * file then slicing it up into batches.		*
 * 							*
 * Note: The tar file will only contain one file (and	*
 * it's aliases.)					*
 ********************************************************/
#ifndef __SLICE_BATCH_H__
#define __SLICE_BATCH_H__

#include <cstdio>

#include "config.h"
#include "filer.h"
#include "batch_b.h"

/********************************************************
 * Create a sliced tar backup.				*
 ********************************************************/
class slice_batch_b: public batch_b {
    private:
	size_t slice_size;	// The size of a single slice
	size_t buffer_limit;	// The size of a buffer for copying

	unsigned int sequence;	// Sequence number of this batch
	bool last;		// Is this the last one?

	string_set current_files;//File set we are writing
	FILE *pipe_file;	// File we are piping into

	std::string name_file_name;// The name of the name file

	unsigned int batch_number;// Number of this batch of files
    public:
	slice_batch_b(const std::string& name,
		const config& config);
	~slice_batch_b() {};
    private:
	slice_batch_b(const slice_batch_b&); // No copy constructor

	// No assignment operator
	slice_batch_b& operator = (const slice_batch_b&);	
    public:
	status add_files(filer &the_filer);
	batch_info_b* create_batch(void);
};

#endif /* __SLICE_BATCH_H__ */


