/********************************************************
 * tape_tape -- Handle low level I/O to a simulated 	*
 * tape.						*
 ********************************************************/
#ifndef __TAPE_TAPE_H__
#define __TAPE_TAPE_H__
#include <unistd.h>

#include "exception.h"
#include "raw_tape.h"

//TODO2: Allow for remote tapes
/********************************************************
 * tape_tape -- Handle tape I/O to a tape.		*
 ********************************************************/
class tape_tape : public raw_tape {
    private:
	int file_limit;		// Debug: Simulate eof here

    public:
	std::string device;	// Device name
	int tape_fd;		// Tape fd
	int file_number;	// Current file number
	int mode;		// Open mode

    public:
	tape_tape(
	    const std::string& i_device,
	    const int i_mode
	);
	// Copy constructor defaults
	// Assignment operator defaults
	~tape_tape()
	{
	    close(tape_fd);
	}
    public:
	int copy_to_mt(
	    const std::string& file_name,
	    const int block_size
	);
	int copy_from_mt(
	    const std::string& file_name,
	    const int block_size
	);
    public:
	int mt_open(const char *const file, const int line);
	void mt_close(const char *const file, const int line);
    public:
	int weof(void);
	int rewind(void);
	int asf(const int position);
	int eod();
	int bsfm(const unsigned int count);
};

#endif /* __TAPE_TAPE_H__ */
