/********************************************************
 * Util -- General purpose utilities with no common	*
 * theme except they are simple, small and stand alone.	*
 ********************************************************/
#ifndef __UTIL_H__
#define __UTIL_H__

#include <string>

#include "types.h"

/********************************************************
 * convert_size -- Convert the size of something 	*
 * into bytes.						*
 *							*
 * Knows about the suffixes MB, K, and b for Megabyte, 	*
 * Kbyte, and block (512 bytes)				*
 ********************************************************/
extern off_t convert_size(
   const std::string& size	// Size to convert
);

/********************************************************
 * encode_string -- Encode funny characters in a string	*
 * 	so it can be printed to a file without 		*
 * 	worrying about them.				*
 * 							*
 * Encoding consists of replacing specials with =xx	*
 * where xx are hex digits.				*
 ********************************************************/
extern std::string encode_string(
    const std::string& input	// String to encode
);
/********************************************************
 * decode_string -- Decode funny characters in a string	*
 * 							*
 * Encoding consists of replacing specials with =xx	*
 * where xx are hex digits.				*
 ********************************************************/
extern std::string decode_string(
    const std::string& input	// String to decode
);
/********************************************************
 * write_name_file -- Write out a tar name file		*
 *  Entries end with \0 for use with the --null		*
 *  							*
 * Returns: 						*
 * 	The name of the temporary file.			*
 ********************************************************/
extern std::string write_name_file(
   const char *const basename,	// The base name of the temp file
   const string_set file_list	// The list of file names
);
/********************************************************
 * str_eq -- Test to see if two strings are equal	*
 * 	(Ignore case)					*
 ********************************************************/
inline bool str_eq(const std::string a, const std::string b)
{
    return (strcasecmp(a.c_str(), b.c_str()) == 0);
}
/********************************************************
 * int_to_string -- Turn an integer into a string	*
 ********************************************************/
std::string int_to_string(const int value);
#endif /* __UTIL_H__ */
