/********************************************************
 * validate -- Table of valid configuration items	*
 * for configuration validation.			*
 ********************************************************/
#include "config.h"

// For the "Options Global" section
struct valid_table global_options_table[] = {
    {"TempDir",	0},
    {NULL,	0}
};

// For the list "InputList" section
struct valid_table input_list_table[] = {
    {"Command",		VALID_FLAG_MANY},
    {"Command0",	VALID_FLAG_MANY},
    {NULL,		0}
};

// For the list "Batch" section
struct valid_table batch_table[] = {
    {"Type",		VALID_FLAG_REQUIRED},
    {"BatchSize",	VALID_FLAG_SIZE|VALID_FLAG_REQUIRED},
    {"FileSize",	VALID_FLAG_SIZE},
    {"BackupCommand",	VALID_FLAG_REQUIRED},
    {"RestoreCommand",	VALID_FLAG_REQUIRED},
    {"VerifyCommand",	VALID_FLAG_REQUIRED},
    {"FilesNeeded",	0},
    {"ID",		0},
    {NULL,		0}
};

// For the list "IO" section
struct valid_table io_table[] = {
    {"Type",		VALID_FLAG_REQUIRED},
    // Tape/IO
    {"BlockSize",	VALID_FLAG_SIZE},
    {"Device",		0},
    {"ChangeScript",	0},
    {"SafeCount",	0},

    // CD/IO 
    {"CdSize",		VALID_FLAG_SIZE},
    {"ImageCommand",	0},
    {"BurnCommand",	0},
    {"PreImage",	0},
    {"MountDir",	0},
    {"MountDev",	0},
    {"MountCmd",	0},
    {NULL,		0}
};

// For the list "Backup" section
struct valid_table backup_table[] = {
    {"InputList",	VALID_FLAG_MANY},
    {"Batch",		VALID_FLAG_MANY},
    {"IO",		VALID_FLAG_MANY|VALID_FLAG_REQUIRED},
    {NULL,		0}
};

//  The JobList section
struct valid_table job_table[] = {
    {"Job",		VALID_FLAG_MANY},
    {NULL,		0}
};
